<script setup lang="ts">
import { globalData } from '~/data';

interface Profile {
  id: number
  username: string;
  email: string
  friends?: [{ username: string, email: string, id: number }]
}

onMounted(async () => profile.value = await getProfile())

const friendName = ref('');

const getProfile = async () => {
  console.log('test');

  const data = await fetch('https://webrtc-nest.onrender.com/users/profile', {
    headers: {
      "Authorization": `Bearer ${globalData.key}`
    }
  });
  console.log(globalData.key);
  
  const json = await data.json()
  console.log(json);

  return json as Profile
}

const callFriend = (id: number) => {
  
}

const removeFriend = async (id: number) => {
  await fetch(`https://webrtc-nest.onrender.com/users/friends/${id}`, {
    method: 'DELETE',
    headers: {
      "Authorization": `Bearer ${globalData.key}`
    }
  })
  profile.value = await getProfile();
}
const profile = ref<Profile>()

const addFriend = async () => {
  const data = await fetch('https://webrtc-nest.onrender.com/users/friends', {
    method: 'POST',
    headers: {
      "Authorization": `Bearer ${globalData.key}`,
      "Content-type": "application/json; charset=UTF-8",
    },
    body: JSON.stringify({
      friendUsername: friendName.value,
    })
  })
  profile.value = await getProfile();
  friendName.value = '';
}

</script>

<template>
    <div class="profile">
    <div>
      <h1>Logged in</h1>
      <h2>Welcome: {{ profile?.username }}</h2>
      <h3>Friends</h3>
      <ul>
        <li v-for="friend in profile?.friends" :key="friend.id">
          <Friend @remove="() => removeFriend(friend.id)" @call="() => callFriend(friend.id)" :username="friend.username" />
        </li>
      </ul>
    </div>
    <form>
      <h3>Add FRIENDS</h3>
      <label for="friendName">Username</label>
      <input v-model="friendName" type="text" name="friendName" id="friendName">
      <button @click.prevent="addFriend">ADD FRIEND</button>
    </form>

  </div>
</template>

<style>
.profile {
  display: flex;
  flex-direction: column;
  justify-content: center;
  justify-content: space-between;
  padding: 1rem;
}

form {
  border: 2px white solid;
  border-radius: 8px;
  display: flex;
  flex-direction: column;
  padding: 1rem;
  justify-content: space-between;
  gap: 1rem;
  min-width: fit-content;
}

button {
  all: unset;
  background-color: blue;
  padding: 1rem;
  text-align: center;
  border-radius: 8px;
}

input {
  all: unset;
  font-size: large;
  max-width: 100%;
  border: 1px white solid;
  padding: .5rem;
  border-radius: 8px;
}

ul {
  padding: 0;
}

li {
  list-style: none;
  margin: 0;
  padding: 0;
}
</style>